#include <stdlib.h>
#include <string.h>
#include <avr/pgmspace.h>

#include "ac_graphics.h"
#include "ac_hitachi.h"
#include "ac_fontinfo.h"
#include "ac_font.h"
#include "ac_defines.h"

#define sgn(value) (value < 0 ? -1 : value == 0 ? 0 : 1)

struct CharacterInfoStruct
{
	unsigned char width;
	unsigned char height;
	unsigned char data[font_max_byte];
};

typedef struct CharacterInfoStruct CharacterInfo;


// hier kann einfach zustzlicher Speicher in .bss hinzugefgt werden.
// geht bei mit problemlos, wenn ich 1000 eintrage
// fehler tritt zb bei 30000 auf
#define fillbufsize 30000

unsigned char buff1[fillbufsize];

struct CharacterInfoStruct font_data[256];

char GetCharFromFlash(PGM_P pointer, int offset)
{
	char c;
	memcpy_P(&c, pointer+offset, sizeof(char));
	return c;
}

void ControlOutput(int i)
{
	// hier ausgabe ersetzen durch geeignete auf dem test device
	// wenn alles glatt geht sollte fr i nur was mit 100 und 200 ausgegeben werden.
	DrawLine(i, 0, i, 20);
}

void InitializeGraphics(void)
{
	PGM_P p;
	int asc = 0;
	int currentchar = 0;
	int i = 0;
	int j;
	unsigned char w;
	unsigned char h;

	HWL_InitializeDisplay();
	ClearScreen();

	// copy pointer to start of font data int progmem
	memcpy_P(&p, &fonts[0], sizeof(PGM_P));

	// read font data into font structure
	while (i<font_size && asc<66)
	{
		// total byte size of current char
		int totalsize = ((int)GetCharFromFlash(p, i) << 8) + (int)GetCharFromFlash(p, i+1);

		if (currentchar == 65)
		{
			// prfung nur fr zeichen 65 (kann in ac_font.c gefunden werden ber suche nach dem ersten 0x41)
			// font struktur ist 2 Byte blocklnge pro zeichen, dann 1 byte ascii code dann jeweils 1 byte fr w und h
			// und dann folgen fontdaten
			ControlOutput(100);
			if (totalsize != 0x23)
			{
				ControlOutput(110);
			}

			// lesen von width und height
			w = GetCharFromFlash(p, i+3);
			if (w != 0x0c)
			{
				ControlOutput(120);
			}

			h = GetCharFromFlash(p, i+4);		
			if (h != 0x14)
			{
				ControlOutput(130);
			}

			// schreiben in fontdaten struktur
			font_data[65].width = w;
			font_data[65].height = h;

			// validieren der werte -> hier ist der fehler nachweisbar
			ControlOutput(220);
			if (font_data[65].width != 0x0c)
			{
				ControlOutput(230);
			}
			if (font_data[65].height != 0x14)
			{
				ControlOutput(240);
			}
			break;

		}
		currentchar++;
		i += totalsize;
	}

}

void DrawLine(int x1, int y1, int x2, int y2)
{
	int i;
	int dx = x2 - x1;
	int dy = y2 - y1;
	int dxabs = abs(dx);
	int dyabs = abs(dy);
	int sdx = sgn(dx);
	int sdy = sgn(dy);
	int x = dyabs >> 1;
	int y = dxabs >> 1;
	int px = x1;
	int py = y1;

	if (dxabs >= dyabs)
	{
		for(i=0; i<dxabs; i++)
		{
			HWL_SetPixel(px,py);
			y += dyabs;
			if (y >= dxabs)
			{
				y -= dxabs;
				py += sdy;
			}
			px += sdx;
		}
	}
	else
	{
		for(i=0; i<dyabs; i++)
		{
			HWL_SetPixel(px,py);
			x += dxabs;
			if (x >= dyabs)
			{
				x -= dyabs;
				px += sdx;
			}
			py += sdy;
		}
	}
	HWL_SetPixel(x2,y2);
}

void ClearScreen()
{
	HWL_ClearScreen();
}

